using System.IdentityModel.Selectors;
using System.IdentityModel.Tokens;
using System.Xml;
using SecurityKeyIdentifierClause = System.IdentityModel.Tokens.SecurityKeyIdentifierClause;
using SecurityToken = System.IdentityModel.Tokens.SecurityToken;

namespace ReactApp.Server.Security;

internal sealed class BearerCredentialsTokenSerializer : SecurityTokenSerializer
{
    protected override bool CanReadKeyIdentifierClauseCore(XmlReader reader) => throw new NotImplementedException();

    protected override bool CanReadKeyIdentifierCore(XmlReader reader) => throw new NotImplementedException();

    protected override bool CanReadTokenCore(XmlReader reader) => throw new NotImplementedException();

    protected override bool CanWriteKeyIdentifierClauseCore(SecurityKeyIdentifierClause keyIdentifierClause) => throw new NotImplementedException();

    protected override bool CanWriteKeyIdentifierCore(SecurityKeyIdentifier keyIdentifier) => throw new NotImplementedException();

    protected override bool CanWriteTokenCore(SecurityToken token) => throw new NotImplementedException();

    protected override SecurityKeyIdentifierClause ReadKeyIdentifierClauseCore(XmlReader reader) => throw new NotImplementedException();

    protected override SecurityKeyIdentifier ReadKeyIdentifierCore(XmlReader reader) => throw new NotImplementedException();

    protected override SecurityToken ReadTokenCore(XmlReader reader, SecurityTokenResolver tokenResolver) => throw new NotImplementedException();

    protected override void WriteKeyIdentifierClauseCore(XmlWriter writer, SecurityKeyIdentifierClause keyIdentifierClause) => throw new NotImplementedException();

    protected override void WriteKeyIdentifierCore(XmlWriter writer, SecurityKeyIdentifier keyIdentifier) => throw new NotImplementedException();

    protected override void WriteTokenCore(XmlWriter writer, SecurityToken token)
    {
        var xmlToken = (GenericXmlSecurityToken) token;
        xmlToken.TokenXml.WriteTo(writer);
    }    
}